###########################################################################
# MMS/MMK file for Samba for VMS
# by Eckart Meyer 1995,1996
# derived from
# Makefile for Samba SMB client/server for unix
# Copyright Andrew Tridgell 1992,1993,1994
#
# 03-Jul-1998	J. Malmberg Special for CMU-IP build
#		Formatted to fit on 80 column printers and terminals.
###########################################################################

O = OBJ_$(__ARCH)
EXE = EXE_$(__ARCH)
OLB = OLB_$(__ARCH)
LIS = LIS_$(__ARCH)
MAP = MAP_$(__ARCH)
.SUFFIXES : .$(EXE) .$(OLB) .$(O) .C

# Add any optimisation or debugging flags here
#FLAGS1 = /DEBUG/NOOPTIMIZE/LIST=$*.$(LIS)/SHOW=ALL
#FLAGS1 = /DEBUG/NOOPTIMIZE $(CDEBUG)
FLAGS1 = $(CDEBUG)
#LIBS1 = /DEBUG
LIBS1 = $(LDEBUG)

#LIBFLAGS = /noglobals
#LIBFLAGS = /selective

.IFDEF __SOCKETSHR__
TCPIP = ,SOCKETSHR_SAMBA.OPT/OPT
OPTFILE = SOCKETSHR_SAMBA.OPT
VMS_SOCKET = CMU_VMS_SOCKET
.ELSE
VMS_SOCKET = TCP
.IFDEF __DECC__
TCPIP =
OPTFILE =
.ELSE
TCPIP = ,SYS$LIBRARY:UCX$IPC/LIB
OPTFILE =
.ENDIF
.ENDIF

.IFDEF __DECC__
VAXCRTL =
.ELSE
.IFDEF __GCC__
VAXCRTL =
.ELSE
VAXCRTL = ,VAXCRTL.OPT/OPT
.ENDIF
.ENDIF

.IFDEF __ALPHA__
LINK = LINK/EXE=$*.$(EXE)
SYSEXE = /SYSEXE
.ELSE
LINK = LINK/EXE=$*.$(EXE)
SYSEXE = ,SYS$SYSTEM:SYS.STB/SELECTIVE_SEARCH
.ENDIF

LIBS2 = $(VAXCRTL) $(TCPIP)

LIBR = LIBRARY/REPLACE

DEFINES =
#ifdef __GCC__
DEFINES = ,__VMS=1
FLAGSM = /OBJ=$*.$(O) /DEFINE=($(DEFINES))
#else
FLAGSM = /OBJ=$*.$(O) /DEFINE=(MODULE_NAME=$*$(DEFINES))
#endif
#LIBSM = /map=$*.$(MAP)
#LIBSM = /debug
LIBSM =

.IFDEF __DECC__
CC = $(CC) conf.h+
.ENDIF
.IFDEF __DECC__
CFLAGS  = $(__CFLAGS) $(FLAGSM) $(FLAGS1)
.ELSE
#INCLUDE_DIRS = [.UBIQX],[.CLIENT],[.mem_man],SAMBA_SRC:,SAMBA_INC:,VMS_SRC:
INCLUDE_DIRS = [.UBIQX],[.CLIENT],[.mem_man],SAMBA_INC:,VMS_SRC:
CFLAGS = /include=($(INCLUDE_DIRS)) $(FLAGSM) $(FLAGSS1)
CFLAGS1 = /include=([.UBIQX],SAMBA_INC:,VMS_SRC:) $(FLAGSM) $(FLAGS1)
.ENDIF
LIBS = $(LIBS1) $(LIBSM) $(LIBS2)

#SPROGS = smbd nmbd
SPROGS = smbd
PROGS1 = smbclient nmbd smbpasswd testparm testprns smbstatus
PROGS = $(PROGS1) nmblookup make_smbcodepage make_printerdef
SCRIPTS = smbtar addtosmbpass


.FIRST
	@ show default
	@ if f$search("vmslib.$(OLB)") .eqs. "" then -
		lib/create/obj vmslib.$(OLB)
	@ if f$search("ubilib.$(OLB)") .eqs. "" then -
		lib/create/obj ubilib.$(OLB)
	@ if f$search("rpc_cli_lib.$(OLB)") .eqs. "" then -
		lib/create/obj rpc_cli_lib.$(OLB)
	@ if f$search("rpc_serv_lib.$(OLB)") .eqs. "" then -
		lib/create/obj rpc_serv_lib.$(OLB)
	@ if f$search("rpc_lib.$(OLB)") .eqs. "" then -
		lib/create/obj rpc_lib.$(OLB)
	@ if f$search("passdb_lib.$(OLB)") .eqs. "" then -
		lib/create/obj passdb_lib.$(OLB)
	@ if f$search("utillib.$(OLB)") .eqs. "" then -
		lib/create/obj utillib.$(OLB)
	@ if f$search("clientutillib.$(OLB)") .eqs. "" then -
		lib/create/obj clientutillib.$(OLB)
	@ if f$search("clientlib.$(OLB)") .eqs. "" then -
		lib/create/obj clientlib.$(OLB)
	@ if f$search("smbdlib.$(OLB)") .eqs. "" then -
		lib/create/obj smbdlib.$(OLB)
	@ if f$search("locklib.$(OLB)") .eqs. "" then -
		lib/create/obj locklib.$(OLB)
	@ if f$search("nmbdlib.$(OLB)") .eqs. "" then -
		lib/create/obj nmbdlib.$(OLB)
	@ if f$search("swatlib.$(OLB)") .eqs. "" then -
		lib/create/obj swatlib.$(OLB)

.IFDEF SAMBA_SETUP_DONE
.ELSE
	@ write sys$output ""
	@ write sys$output "Type ""@[-.packaging.vms]setup"" and then try again"
	@ write sys$output ""
	@ a = samba_setup_done	! produces an error an stops mms
.ENDIF

.c.$(O) : $(INCLUDES)
	$(CC) $*.c $(CFLAGS)
	$(LIBR) samba.$(OLB) $*.$(O)

all : $(SPROGS) $(PROGS)
	-@ !

INCLUDES1 = version.h local.h includes.h smb.h conf.h
INCLUDES2 = trans2.h

UBI_INCLUDES = [.ubiqx]ubi_sLinkList.h [.ubiqx]ubi_dLinkList.h \
	[.ubiqx]ubi_Cache.h

VMS_INCLUDES = vms_src:vms1.h vms_src:vms2.h

INCLUDES = $(INCLUDES1) $(INCLUDES2) $(UBI_INCLUDES) $(VMS_INCLUDES)

######################################################################
# object modules
######################################################################

#
# VMS Specific Modules
#============================================
VMSOBJ = vms_sup.$(O) vms_dir.$(O) get.$(O) stat.$(O) priv.$(O) \
	setuid.$(O) setuser.$(O) stm_read.$(O) posixtim.$(O) \
	utime.$(O) $(VMS_SOCKET).$(O) longfile_2_vms.$(O) \
	vms_2_longfile.$(O) vms_dir_2_file.$(O) vms_dev_translate.$(O) \
	vms_lp_load.$(O)

#
# modules in the ubiqx library from Chris Hertel
#===============================================
UBIOBJ = ubi_dLinkList.$(O) ubi_Cache.$(O) ubi_SplayTree.$(O) \
	ubi_BinTree.$(O) ubi_sLinkList.$(O)

#
# client code that needs to do in the server in the lib/rpc directory.
#=======================================================================
RPC_CLIENT_SERVER_SUBSET_OBJ = cli_login.$(O) cli_netlogon.$(O) cli_pipe.$(O)
#
# client specific object code in the lib/rpc directory
#=======================================================================
RPC_CLI_OBJ = $(RPC_CLIENT_SERVER_SUBSET_OBJ) cli_samr.$(O)\
	cli_wkssvc.$(O) cli_lsarpc.$(O) \
	cli_srvsvc.$(O) ntclienttrust.$(O)

# server specific object code in the lib/rpc directory
RPC_SERV_OBJ =  srv_lsa.$(O) srv_netlog.$(O) srv_reg.$(O) \
	srv_srvsvc.$(O) srv_wkssvc.$(O)  \
	srv_lsa_hnd.$(O) srv_pipe_hnd.$(O) \
	srv_samr.$(O) srv_util.$(O)

# parse object files in the lib/rpc subdirectory
RPC_OBJ = parse_lsa.$(O) parse_net.$(O) parse_reg.$(O) \
	parse_samr.$(O) parse_wks.$(O) parse_misc.$(O) \
	parse_prs.$(O) parse_rpc.$(O) parse_srv.$(O)


# password database object files
PASSDB_OBJ = passdb.$(O) ldap.$(O) smbpass.$(O) nisppass.$(O) smbpassfile.$(O)

UTILOBJ1 = $(VMSOBJ) util.$(O) system.$(O) charset.$(O) kanji.$(O) \
	   fault.$(O) smbencrypt.$(O) smbdes.$(O) charcnv.$(O) genrand.$(O)
UTILOBJ2 = $(UTILOBJ1) md4.$(O) loadparm.$(O) params.$(O) \
	   pcap.$(O) username.$(O) time.$(O) membuffer.$(O) \
	   namequery.$(O) nmblib.$(O)
UTILOBJ = $(UTILOBJ2) credentials.$(O) interface.$(O) \
	   print_svid.$(O) smberr.$(O) mem_man.$(O) pidfile.$(O) \
	   slprintf.$(O) $(SSL_OBJ)

# Client utility object files.
CLIENTUTIL = clientgen.$(O) nterr.$(O)

# object code needed for programs that handle the the locking files
LOCKOBJ = locking_shm.$(O) locking_slow.$(O) locking.$(O) shmem.$(O) \
	shmem_sysv.$(O)


# object code for smbd
SMBDOBJ1 = $(UTILOBJ) trans2.$(O) message.$(O)  dir.$(O)\
	printing.$(O) $(INCLUDES)

SMBDOBJ2 = ipc.$(O) reply.$(O) mangle.$(O) chgpasswd.$(O) password.$(O) \
	quotas.$(O) uid.$(O) $(INCLUDES)

SMBDOBJ3 = predict.$(O) pipes.$(O) server.$(O) access.$(O) $(INCLUDES)

SMBDOBJ4 = ufc.$(O) connection.$(O) groupname.$(O) $(INCLUDES)


SMBDOBJ = $(SMBDOBJ1) $(SMBDOBJ2) $(SMBDOBJ3) $(SMBDOBJ4) $(UBIOBJ) $(RPC_OBJ) \
	$(RPC_SERV_OBJ) $(RPC_CLIENT_SERVER_SUBSET_OBJ) $(VTP_OBJ) \
	$(LOCKOBJ) $(CLIENTUTIL) $(PASSDB_OBJ)


# object code for nmbd
NMBDOBJ1 = $(PASSDB_OBJ) nmbd.$(O) nmbd_packets.$(O) nmbd_lmhosts.$(O) \
	nmbd_become_dmb.$(O) nmbd_logonnames.$(O)
NMBDOBJ2 = nmbd_browserdb.$(O) nmbd_responserecordsdb.$(O) \
	nmbd_workgroupdb.$(O) nmbd_serverlistdb.$(O)
NMBDOBJ3 = nmbd_subnetdb.$(O) nmbd_browsesync.$(O) nmbd_nodestatus.$(O) \
	nmbd_mynames.$(O) nmbd_mynames.$(O) nmbd_winsproxy.$(O)
NMBDOBJ4 = nmbd_sendannounce.$(O) nmbd_processlogon.$(O) \
	nmbd_incomingdgrams.$(O)
NMBDOBJ5 = asyncdns.$(O) nmbd_winsserver.$(O) nmbd_incomingrequests.$(O) \
	nmbd_nameregister.$(O)
NMBDOBJ6 = nmbd_namerelease.$(O) nmbd_namequery.$(O) nmbd_become_lmb.$(O) \
	nmbd_elections.$(O) nmbd_namelistdb.$(O)
NMBDOBJ = $(UTILOBJ) $(NMBDOBJ1) $(NMBDOBJ2) $(NMBDOBJ3) $(NMBDOBJ4) \
	$(NMBDOBJ5) $(NMBDOBJ6) $(CLIENTUTIL) $(UBIOBJ)

# object files for smbclient
CLIENT_OBJ = client.$(O) clientutil.$(O) clitar.$(O) getsmbpass.$(O) \
	$(UTILOBJ)

# object files for smbmount
MOUNT_OBJ = smbmount.$(O) clientutil.$(O) getsmbpass.$(O) $(UTILOBJ)

# object files for smbmnt
MNT_OBJ = smbmnt.$(O)

# object files for smbumount
UMOUNT_OBJ = smbumount.$(O) $(UTILOBJ)

# object files for smbstatus
STATUS_OBJ = status.$(O) $(UTILOBJ) $(LOCKOBJ)

# object files for nmblookup
LOOKUP_OBJ = nmblookup.$(O) $(UTILOBJ)

# object files for swat
SWAT_OBJ = swat.$(O) statuspage.$(O) cgi.$(O) diagnose.$(O) \
	startstop.$(O) password.$(O) $(PASSDB_OBJ) \
	$(RPC_CLIENT_SERVER_SUBSET_OBJ) $(RPC_OBJ) $(UTILOBJ) \
	$(LOCKOBJ) $(CLIENTUTIL)

# object files to be auto-prototyped
PROTOOBJ = $(UTILOBJ) $(SMBDOBJ) $(NMBDOBJ) $(LOCKOBJ) $(CLIENT_OBJ) \
	$(STATUS_OBJ) $(SWAT_OBJ) $(CLIENTUTIL) $(PASSDB_OBJ)


######################################################################
# now the rules...
######################################################################

smbd :		smbd.$(EXE)
	-@ !

#smbrun :	smbrun.$(EXE)
#	-@ !

nmblookup :	nmblookup.$(EXE)
	-@ !

nmbd :		nmbd.$(EXE)
	-@ !

smbclient :	smbclient.$(EXE)
	-@ !

smbstatus :	smbstatus.$(EXE)
	-@ !

testparm :	testparm.$(EXE)
	-@ !

testprns :	testprns.$(EXE)
	-@ !

smbpasswd :	smbpasswd.$(EXE)
	-@ !

make_printerdef : make_printerdef.$(EXE)
	-@ !

make_smbcodepage : make_smbcodepage.$(EXE)


smbd.$(EXE) :	$(SMBDOBJ) $(OPTFILE)
	$(LINK) server.$(O), smbdlib.$(OLB)/lib,  -
		 ubilib.$(OLB)/LIB, -
		rpc_serv_lib.$(OLB)/lib, -
		rpc_cli_lib.$(OLB)/lib, rpc_lib.$(OLB)/lib,-
		passdb_lib.$(OLB)/lib, utillib.$(OLB)/LIB, vmslib.$(OLB)/lib,-
		locklib.$(OLB)/lib $(LIBS) $(SYSEXE)

#smbrun.$(EXE) :	smbrun.$(O)
#	$(LINK) smbrun.$(O) $(LIBS)

nmblookup.$(EXE) : $(LOOKUP_OBJ) nmblib.$(O) $(UTILOBJ) $(OPTFILE)
	$(LINK) nmblookup.$(O),utillib.$(OLB)/lib, vmslib.$(OLB)/LIB $(LIBS)

nmbd.$(EXE) :	$(NMBDOBJ) $(OPTFILE)
	$(LINK) nmbd.$(O), nmbdlib.$(OLB)/lib, ubilib.$(OLB)/lib, -
	utillib.$(OLB)/lib, -
	vmslib.$(OLB)/lib, passdb_lib.$(OLB)/lib $(LIBS)

smbclient.$(EXE) : $(CLIENT_OBJ) $(OPTFILE) $(CLIENTUTIL)
	$(LINK) client.$(O), clientlib.$(OLB)/lib, -
	 utillib.$(OLB)/lib, vmslib.$(OLB)/LIB $(LIBS)

smbtorture.$(EXE) : torture.$(O) getsmbpass.$(O) $(UTILOBJ) $(CLIENTUTIL) \
		$(OPTFILE)
	$write sys$output "Linking smbtorture"
	$(LINK) torture.$(O) getsmbpass.$(O), utillib.$(OLB)/LIB, -
		vmslib.$(OLB)/LIB $(LIBS)

smbstatus.$(EXE) : status.$(O) $(PARAMOBJ) $(OPTFILE)
	$(LINK) status.$(O), utillib.$(OLB)/lib, vmslib.$(OLB)/LIB, -
		locklib.$(OLB)/lib  $(LIBS)

testparm.$(EXE) : testparm.$(O) $(PARAMOBJ) $(OPTFILE) $(SMBDOBJ)
	$(LINK) testparm.$(O), utillib.$(OLB)/lib, smbdlib.$(OLB)/lib,-
		vmslib.$(OLB)/lib $(LIBS)

testprns.$(EXE) : testprns.$(O) $(PARAMOBJ) $(OPTFILE)
	$(LINK) testprns.$(O), utillib.$(OLB)/lib, vmslib.$(OLB)/lib $(LIBS)

smbpasswd.$(EXE) : smbpasswd.$(O) getsmbpass.$(O) $(PASSDB_OBJ) \
		$(UTILOBJ) $(CLIENTUTIL) $(RPC_CLIENT_SERVER_SUBSET_OBJ) \
		$(RPC_OBJ) $(OPTFILE)
	$(LINK) smbpasswd.$(O), getsmbpass.$(O), -
		clientutillib.$(OLB)/lib, -
		rpc_cli_lib.$(OLB)/lib, rpc_lib.$(OLB)/lib, -
		utillib.$(OLB)/lib, vmslib.$(OLB)/lib, -
		passdb_lib.$(OLB)/lib -
		$(LIBS)

make_smbcodepage.$(EXE) : make_smbcodepage.$(O),$(UTILOBJ)
	$(LINK) make_smbcodepage.$(O),utillib.$(OLB)/lib,-
		vmslib.$(OLB)/lib $(LIBS)

make_printerdef.$(EXE) : make_printerdef.$(O),$(UTILOBJ)
	$(LINK) make_printerdef.$(O),utillib.$(OLB)/lib, -
		vmslib.$(OLB)/lib $(LIBS)

wsmbstatus.$(EXE) : swmbstatus.$(O) $(UTILOBJ)
	$(LINK) smbstatus.$(O), utillib.$(OLB)/lib, vmslib.$(OLB)/lib $(LIBS)

swat.$(EXE) : $(SWAT_OBJ)
	$(LINK) swat.$(O), swat_lib.$(OLB)/lib, GNU_CC_LIBRARY:GCC2DECC.OPT/OPT


conf.h : vms_src:setup.com
	write sys$output "CONF.H is probably out of date."
	write sys$output "Run the SETUP.COM again."
	exit 24 !bomb out the build.


server.$(O) : server.c $(INCLUDES)
	$(CC) $*.c $(CFLAGS)

nmbd.$(O) :	nmbd.c $(INCLUDES)
	$(CC) $*.c $(CFLAGS)

nmblookup.$(O) : nmblookup.c $(INCLUDES)
	$(CC) $*.c $(CFLAGS)

status.$(O) :	status.c $(INCLUDES)
	$(CC) $*.c $(CFLAGS)

testparm.$(O) :	testparm.c $(INCLUDES)
	$(CC) $*.c $(CFLAGS)

client.$(O) :	client.c $(INCLUDES)
	$(CC) $*.c $(CFLAGS)

smbpasswd.$(O) : smbpasswd_vms.c $(INCLUDES)
	$(CC) $*.c $(CFLAGS)

testprns.$(O) :	testprns.c $(INCLUDES)
	$(CC) $*.c $(CFLAGS)

make_smbcodepage.$(O) : make_smbcodepage.c $(INCLUDES)
	$(CC) $*.c $(CFLAGS)

make_printerdef.$(O) : make_printerdef.c $(INCLUDES)
	$(CC) $*.c $(CFLAGS)

swmbstatus.$(O) : swmbstatus.c $(INCLUDES)
	$(CC) $*.c $(CFLAGS)

#
# VMS support modules
#====================================================

vms_sup.$(O) :	vms_src:vms_sup.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) vmslib.$(OLB) $*.$(O) $(LIBFLAGS)

vms_dir.$(O) :	vms_src:vms_dir.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) vmslib.$(OLB) $*.$(O) $(LIBFLAGS)

get.$(O) :	vms_src:get.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) vmslib.$(OLB) $*.$(O) $(LIBFLAGS)

stat.$(O) :	vms_src:stat.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) vmslib.$(OLB) $*.$(O) $(LIBFLAGS)

#getopt.$(O) :	vms_src:getopt.c $(INCLUDES)
#	$(CC) $(MMS$SOURCE) $(CFLAGS)
#	$(LIBR) vmslib.$(OLB) $*.$(O) $(LIBFLAGS)

#hpwd.$(O) :	vms_src:hpwd.c $(INCLUDES)
#	$(CC) $(MMS$SOURCE) $(CFLAGS)
#	$(LIBR) vmslib.$(OLB) $*.$(O) $(LIBFLAGS)

priv.$(O) :	vms_src:priv.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) vmslib.$(OLB) $*.$(O) $(LIBFLAGS)

setuid.$(O) :	vms_src:setuid.c
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) vmslib.$(OLB) $*.$(O) $(LIBFLAGS)

setuser.$(O) :	vms_src:setuser.mar
	MACRO $(MMS$SOURCE)/OBJECT=$(MMS$TARGET)
	$(LIBR) vmslib.$(OLB) $*.$(O) $(LIBFLAGS)

stm_read.$(O) :	vms_src:stm_read.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) vmslib.$(OLB) $*.$(O) $(LIBFLAGS)

posixtim.$(O) :	vms_src:posixtim.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) vmslib.$(OLB) $*.$(O) $(LIBFLAGS)

utime.$(O) :	vms_src:utime.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) vmslib.$(OLB) $*.$(O) $(LIBFLAGS)

$(VMS_SOCKET).$(O) : vms_src:$(VMS_SOCKET).c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS1)
	$(LIBR) vmslib.$(OLB) $*.$(O) $(LIBFLAGS)

longfile_2_vms.$(O) : longfile_2_vms.c longfile_vms.h
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) vmslib.$(OLB) $*.$(O) $(LIBFLAGS)

vms_2_longfile.$(O) : vms_2_longfile.c longfile_vms.h
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) vmslib.$(OLB) $*.$(O) $(LIBFLAGS)

vms_dir_2_file.$(O) : vms_dir_2_file.c longfile_vms.h
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) vmslib.$(OLB) $*.$(O) $(LIBFLAGS)

vms_dev_translate.$(O) : vms_dev_translate.c longfile_vms.h
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) vmslib.$(OLB) $*.$(O) $(LIBFLAGS)

vms_lp_load.$(O) : vms_lp_load.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) vmslib.$(OLB) $*.$(O) $(LIBFLAGS)

#
# UBI Stuff
#=====================
ubi_dLinkList.$(O) : [.UBIQX]ubi_dLinkList.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) ubilib.$(OLB) $*.$(O) $(LIBFLAGS)

ubi_Cache.$(O) : [.UBIQX]ubi_Cache.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) ubilib.$(OLB) $*.$(O) $(LIBFLAGS)

ubi_SplayTree.$(O) : [.UBIQX]ubi_SplayTree.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) ubilib.$(OLB) $*.$(O) $(LIBFLAGS)

ubi_BinTree.$(O) : [.UBIQX]ubi_BinTree.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) ubilib.$(OLB) $*.$(O) $(LIBFLAGS)

ubi_sLinkList.$(O) : [.UBIQX]ubi_sLinkList.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) ubilib.$(OLB) $*.$(O) $(LIBFLAGS)

#
# RPC Client
#======================

cli_login.$(O) : rpccli:cli_login.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) rpc_cli_lib.$(OLB) $*.$(O) $(LIBFLAGS)

cli_lsarpc.$(O) : rpccli:cli_lsarpc.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) rpc_cli_lib.$(OLB) $*.$(O) $(LIBFLAGS)

cli_netlogon.$(O) : rpccli:cli_netlogon.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) rpc_cli_lib.$(OLB) $*.$(O) $(LIBFLAGS)

cli_pipe.$(O) : rpccli:cli_pipe.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) rpc_cli_lib.$(OLB) $*.$(O) $(LIBFLAGS)

cli_samr.$(O) : rpccli:cli_samr.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) rpc_cli_lib.$(OLB) $*.$(O) $(LIBFLAGS)

cli_srvsvc.$(O) : rpccli:cli_srvsvc.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) rpc_cli_lib.$(OLB) $*.$(O) $(LIBFLAGS)

cli_wkssvc.$(O) : rpccli:cli_wkssvc.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) rpc_cli_lib.$(OLB) $*.$(O) $(LIBFLAGS)

ntclienttrust.$(O) : rpccli:ntclienttrust.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) rpc_cli_lib.$(OLB) $*.$(O) $(LIBFLAGS)


#
# RPC SERVER LIB
#==========================
srv_lsa.$(O) : rpcsvr:srv_lsa.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) rpc_serv_lib.$(OLB) $*.$(O) $(LIBFLAGS)

srv_netlog.$(O) : rpcsvr:srv_netlog.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) rpc_serv_lib.$(OLB) $*.$(O) $(LIBFLAGS)

srv_reg.$(O) : rpcsvr:srv_reg.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) rpc_serv_lib.$(OLB) $*.$(O) $(LIBFLAGS)

srv_srvsvc.$(O) : rpcsvr:srv_srvsvc.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) rpc_serv_lib.$(OLB) $*.$(O) $(LIBFLAGS)

srv_wkssvc.$(O) : rpcsvr:srv_wkssvc.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) rpc_serv_lib.$(OLB) $*.$(O) $(LIBFLAGS)

srv_lsa_hnd.$(O) : rpcsvr:srv_lsa_hnd.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) rpc_serv_lib.$(OLB) $*.$(O) $(LIBFLAGS)

srv_pipe_hnd.$(O) : rpcsvr:srv_pipe_hnd.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) rpc_serv_lib.$(OLB) $*.$(O) $(LIBFLAGS)

srv_samr.$(O) : rpcsvr:srv_samr.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) rpc_serv_lib.$(OLB) $*.$(O) $(LIBFLAGS)

srv_util.$(O) : rpcsvr:srv_util.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) rpc_serv_lib.$(OLB) $*.$(O) $(LIBFLAGS)

#
# RPC_OBJ
#===============================================
parse_lsa.$(O) : rpcprs:parse_lsa.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) rpc_lib.$(OLB) $*.$(O) $(LIBFLAGS)

parse_net.$(O) : rpcprs:parse_net.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) rpc_lib.$(OLB) $*.$(O) $(LIBFLAGS)

parse_reg.$(O) : rpcprs:parse_reg.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) rpc_lib.$(OLB) $*.$(O) $(LIBFLAGS)

parse_samr.$(O) : rpcprs:parse_samr.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS1)
	$(LIBR) rpc_lib.$(OLB) $*.$(O) $(LIBFLAGS)

parse_wks.$(O) : rpcprs:parse_wks.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) rpc_lib.$(OLB) $*.$(O) $(LIBFLAGS)

parse_misc.$(O) : rpcprs:parse_misc.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS1)
	$(LIBR) rpc_lib.$(OLB) $*.$(O) $(LIBFLAGS)

parse_prs.$(O) : rpcprs:parse_prs.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) rpc_lib.$(OLB) $*.$(O) $(LIBFLAGS)

parse_rpc.$(O) : rpcprs:parse_rpc.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) rpc_lib.$(OLB) $*.$(O) $(LIBFLAGS)

parse_srv.$(O) : rpcprs:parse_srv.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) rpc_lib.$(OLB) $*.$(O) $(LIBFLAGS)

#
# PASSWORD DATABASE
#========================================

passdb.$(O) : vms_passdb.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) passdb_lib.$(OLB) $*.$(O) $(LIBFLAGS)

ldap.$(O) : ldap.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) passdb_lib.$(OLB) $*.$(O) $(LIBFLAGS)

smbpass.$(O) : smbpass.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) passdb_lib.$(OLB) $*.$(O) $(LIBFLAGS)

nisppass.$(O) : nisppass.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) passdb_lib.$(OLB) $*.$(O) $(LIBFLAGS)

smbpassfile.$(O) : smbpassfile.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS1)
	$(LIBR) passdb_lib.$(OLB) $*.$(O) $(LIBFLAGS)

#
# General Utilities
#==============================
util.$(O) : util.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) utillib.$(OLB) $*.$(O) $(LIBFLAGS)

system.$(O) : system.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) utillib.$(OLB) $*.$(O) $(LIBFLAGS)

charset.$(O) : charset.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) utillib.$(OLB) $*.$(O) $(LIBFLAGS)

kanji.$(O) : kanji.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) utillib.$(OLB) $*.$(O) $(LIBFLAGS)

fault.$(O) : fault.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) utillib.$(OLB) $*.$(O) $(LIBFLAGS)

smbencrypt.$(O) : smbencrypt.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS1)
	$(LIBR) utillib.$(OLB) $*.$(O) $(LIBFLAGS)

smbdes.$(O) : smbdes.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) utillib.$(OLB) $*.$(O) $(LIBFLAGS)

charcnv.$(O) : charcnv_vms.c longfile_vms.h $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) utillib.$(OLB) $*.$(O) $(LIBFLAGS)

genrand.$(O) : genrand.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) utillib.$(OLB) $*.$(O) $(LIBFLAGS)

md4.$(O) : md4.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) utillib.$(OLB) $*.$(O) $(LIBFLAGS)

loadparm.$(O) : loadparm.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) utillib.$(OLB) $*.$(O) $(LIBFLAGS)

params.$(O) : params.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) utillib.$(OLB) $*.$(O) $(LIBFLAGS)

pcap.$(O) : pcap.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) utillib.$(OLB) $*.$(O) $(LIBFLAGS)

username.$(O) : username.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) utillib.$(OLB) $*.$(O) $(LIBFLAGS)

time.$(O) : time.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) utillib.$(OLB) $*.$(O) $(LIBFLAGS)

membuffer.$(O) : membuffer.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) utillib.$(OLB) $*.$(O) $(LIBFLAGS)

namequery.$(O) : namequery.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) utillib.$(OLB) $*.$(O) $(LIBFLAGS)

nmblib.$(O) : nmblib.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) utillib.$(OLB) $*.$(O) $(LIBFLAGS)

credentials.$(O) : credentials.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) utillib.$(OLB) $*.$(O) $(LIBFLAGS)

interface.$(O) : interface.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) utillib.$(OLB) $*.$(O) $(LIBFLAGS)

#replace.$(O) : replace.c $(INCLUDES)
#	$(CC) $(MMS$SOURCE) $(CFLAGS)
#	$(LIBR) utillib.$(OLB) $*.$(O) $(LIBFLAGS)

print_svid.$(O) : print_svid.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) utillib.$(OLB) $*.$(O) $(LIBFLAGS)

smberr.$(O) : smberr.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) utillib.$(OLB) $*.$(O) $(LIBFLAGS)

#
# New stuff
#==================
mem_man.$(O) : [.mem_man]mem_man.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) utillib.$(OLB) $*.$(O) $(LIBFLAGS)

pidfile.$(O) : pidfile.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) utillib.$(OLB) $*.$(O) $(LIBFLAGS)

slprintf.$(O) : slprintf.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) utillib.$(OLB) $*.$(O) $(LIBFLAGS)

clientgen.$(O) : clientgen.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) utillib.$(OLB) $*.$(O) $(LIBFLAGS)

nterr.$(O) : nterr.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) utillib.$(OLB) $*.$(O) $(LIBFLAGS)

#
# SMBD Process
#======================================

trans2.$(O) : trans2.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) smbdlib.$(OLB) $*.$(O) $(LIBFLAGS)

message.$(O) : message.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) smbdlib.$(OLB) $*.$(O) $(LIBFLAGS)

dir.$(O) : dir.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) smbdlib.$(OLB) $*.$(O) $(LIBFLAGS)

printing.$(O) : printing.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) smbdlib.$(OLB) $*.$(O) $(LIBFLAGS)

ipc.$(O) : ipc.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) smbdlib.$(OLB) $*.$(O) $(LIBFLAGS)

reply.$(O) : reply.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) smbdlib.$(OLB) $*.$(O) $(LIBFLAGS)

mangle.$(O) : mangle.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) smbdlib.$(OLB) $*.$(O) $(LIBFLAGS)

chgpasswd.$(O) : chgpasswd.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) smbdlib.$(OLB) $*.$(O) $(LIBFLAGS)

password.$(O) : password.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) smbdlib.$(OLB) $*.$(O) $(LIBFLAGS)

quotas.$(O) : quotas.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) smbdlib.$(OLB) $*.$(O) $(LIBFLAGS)

uid.$(O) : uid.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) smbdlib.$(OLB) $*.$(O) $(LIBFLAGS)

predict.$(O) : predict.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) smbdlib.$(OLB) $*.$(O) $(LIBFLAGS)

pipes.$(O) : pipes.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) smbdlib.$(OLB) $*.$(O) $(LIBFLAGS)


access.$(O) : access.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) smbdlib.$(OLB) $*.$(O) $(LIBFLAGS)

ufc.$(O) : ufc.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) smbdlib.$(OLB) $*.$(O) $(LIBFLAGS)

connection.$(O) : connection.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) smbdlib.$(OLB) $*.$(O) $(LIBFLAGS)

groupname.$(O) : groupname.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) smbdlib.$(OLB) $*.$(O) $(LIBFLAGS)


#
# Locking code
#=====================================
locking_shm.$(O) : locking_shm.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) locklib.$(OLB) $*.$(O) $(LIBFLAGS)

locking_slow.$(O) : locking_slow.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) locklib.$(OLB) $*.$(O) $(LIBFLAGS)

locking.$(O) : locking.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) locklib.$(OLB) $*.$(O) $(LIBFLAGS)

shmem.$(O) : shmem.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) locklib.$(OLB) $*.$(O) $(LIBFLAGS)

shmem_sysv.$(O) : shmem_sysv.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) locklib.$(OLB) $*.$(O) $(LIBFLAGS)

#
# NMBD process
#======================================================

nmbd_packets.$(O) : nmbd_packets.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) nmbdlib.$(OLB) $*.$(O) $(LIBFLAGS)

nmbd_lmhosts.$(O) : nmbd_lmhosts.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) nmbdlib.$(OLB) $*.$(O) $(LIBFLAGS)

nmbd_become_dmb.$(O) : nmbd_become_dmb.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) nmbdlib.$(OLB) $*.$(O) $(LIBFLAGS)

nmbd_logonnames.$(O) : nmbd_logonnames.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) nmbdlib.$(OLB) $*.$(O) $(LIBFLAGS)

nmbd_browserdb.$(O) : nmbd_browserdb.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) nmbdlib.$(OLB) $*.$(O) $(LIBFLAGS)

nmbd_responserecordsdb.$(O) : nmbd_responserecordsdb.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS1)
	$(LIBR) nmbdlib.$(OLB) $*.$(O) $(LIBFLAGS)

nmbd_workgroupdb.$(O) : nmbd_workgroupdb.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) nmbdlib.$(OLB) $*.$(O) $(LIBFLAGS)

nmbd_serverlistdb.$(O) : nmbd_serverlistdb.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS1)
	$(LIBR) nmbdlib.$(OLB) $*.$(O) $(LIBFLAGS)

nmbd_subnetdb.$(O) : nmbd_subnetdb.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) nmbdlib.$(OLB) $*.$(O) $(LIBFLAGS)

nmbd_browsesync.$(O) : nmbd_browsesync.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) nmbdlib.$(OLB) $*.$(O) $(LIBFLAGS)

nmbd_nodestatus.$(O) : nmbd_nodestatus.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) nmbdlib.$(OLB) $*.$(O) $(LIBFLAGS)

nmbd_mynames.$(O) : nmbd_mynames.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) nmbdlib.$(OLB) $*.$(O) $(LIBFLAGS)

nmbd_winsproxy.$(O) : nmbd_winsproxy.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) nmbdlib.$(OLB) $*.$(O) $(LIBFLAGS)

nmbd_sendannounce.$(O) : nmbd_sendannounce.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS1)
	$(LIBR) nmbdlib.$(OLB) $*.$(O) $(LIBFLAGS)

nmbd_processlogon.$(O) : nmbd_processlogon.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS1)
	$(LIBR) nmbdlib.$(OLB) $*.$(O) $(LIBFLAGS)

nmbd_incomingdgrams.$(O) : nmbd_incomingdgrams.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS1)
	$(LIBR) nmbdlib.$(OLB) $*.$(O) $(LIBFLAGS)

asyncdns.$(O) : asyncdns.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) nmbdlib.$(OLB) $*.$(O) $(LIBFLAGS)

nmbd_winsserver.$(O) : nmbd_winsserver.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS1)
	$(LIBR) nmbdlib.$(OLB) $*.$(O) $(LIBFLAGS)

nmbd_incomingrequests.$(O) : nmbd_incomingrequests.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS1)
	$(LIBR) nmbdlib.$(OLB) $*.$(O) $(LIBFLAGS)

nmbd_nameregister.$(O) : nmbd_nameregister.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS1)
	$(LIBR) nmbdlib.$(OLB) $*.$(O) $(LIBFLAGS)

nmbd_namerelease.$(O) : nmbd_namerelease.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) nmbdlib.$(OLB) $*.$(O) $(LIBFLAGS)

nmbd_namequery.$(O) : nmbd_namequery.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS1)
	$(LIBR) nmbdlib.$(OLB) $*.$(O) $(LIBFLAGS)

nmbd_become_lmb.$(O) : nmbd_become_lmb.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS1)
	$(LIBR) nmbdlib.$(OLB) $*.$(O) $(LIBFLAGS)

nmbd_elections.$(O) : nmbd_elections.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS1)
	$(LIBR) nmbdlib.$(OLB) $*.$(O) $(LIBFLAGS)

nmbd_namelistdb.$(O) : nmbd_namelistdb.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS1)
	$(LIBR) nmbdlib.$(OLB) $*.$(O) $(LIBFLAGS)

#
# Client Stuff
#=================================

clientutil.$(O) : clientutil.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) clientlib.$(OLB) $*.$(O) $(LIBFLAGS)

clitar.$(O) : clitar.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) clientlib.$(OLB) $*.$(O) $(LIBFLAGS)

getsmbpass.$(O) : getsmbpass.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) clientlib.$(OLB) $*.$(O) $(LIBFLAGS)


#
# Misc Stuff
#===========================


#
# WEB stuff
#======================
swat.$(O) : [.web]swat.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)

cgi.$(O) : [.web]cgi.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) weblib.$(OLB) $*.$(O) $(LIBFLAGS)

diagnose.$(O) : [.web]diagnose.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) weblib.$(OLB) $*.$(O) $(LIBFLAGS)

startstop.$(O) : [.web]startstop.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) weblib.$(OLB) $*.$(O) $(LIBFLAGS)

statuspage.$(O) : [.web]statuspage.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) weblib.$(OLB) $*.$(O) $(LIBFLAGS)


#
# SMB stuff
#===================
#client_file_system.$(O) : SMBSRC:client_file_system.c
#	$(CC) $(MMS$SOURCE) $(CFLAGS)
#	$(LIBR) smblib.$(OLB) $*.$(O) $(LIBFLAGS)

client_ipc.$(O) : SMBSRC:client_ipc.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) smblib.$(OLB) $*.$(O) $(LIBFLAGS)

client_mount.$(O) : SMBSRC:client_mount.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) smblib.$(OLB) $*.$(O) $(LIBFLAGS)

client_print.$(O) : SMBSRC:client_print.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) smblib.$(OLB) $*.$(O) $(LIBFLAGS)

client_setup.$(O) : SMBSRC:client_setup.c $(INCLUDES)
	$(CC) $(MMS$SOURCE) $(CFLAGS)
	$(LIBR) smblib.$(OLB) $*.$(O) $(LIBFLAGS)

