/*
   Unix SMB/Netbios implementation.
   Version 1.9.
   Copyright (C) Andrew Tridgell 1994-1997

   This file is part of the port to OpenVMS
   General VMS support routines.
   Copyright (C) Eckart Meyer 1996-1997

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
/*	vms_sup.c
 *	V1.3			2-Mar-1997	IfN/Mey
 *
 *	Copyright E. Meyer <meyer@ifn.ing.tu-bs.de>
 *+
 * Samba VMS support.
 * Misc. routines not present on VMS.
 *
 * NOTE: includes.h *IS* included here.
 *-
 */

 /* Most routines need the global includes */
/*----------------------------------------*/
#include "vms_user_options.h"

/* #define __FCNTL_LOADED 1 */

#include "includes.h"


#ifndef __GNUC__
#include <starlet.h>
#include <lib$routines.h>
#endif
#include <descrip.h>
#include <dvidef.h>
#include <quidef.h>
#include <jpidef.h>
#include <ssdef.h>
#include <rmsdef.h>
#include <string.h>
#include <unixlib.h>
#ifdef chmod
#undef chmod
#endif
 /* Something is clobbering this from the header file */
/*---------------------------------------------------*/
int chmod(const char * filename, unsigned mode);

time_t posix_mktime(struct tm *);

  /* Some one with the SAMBA project had a bad experience with string */
 /*  functions on some platform, so all platforms must suffer	     */
/*------------------------------------------------------------------*/
#ifdef strcpy
#undef strcpy
#endif
#ifdef strcat
#undef strcat
#endif
#ifdef strchr
#undef strchr
#endif
#ifdef strrchr
#undef strrchr
#endif

/* TRUE and FALSE ... Where are these defined? */
#ifndef TRUE
#define TRUE (1)
#endif
#ifndef FALSE
#define FALSE (0)
#endif

/* For DEC C, the string functions are still broken, since the
** compiler really wants to replace them with inline code
** and the SAMBA stuff removes that information.
*/

#if 0
char *VMSMakeFilename(char * __vms_buf, char * __file_spec);
#endif

/* SAMBA debugging */
extern int DEBUGLEVEL;

struct itm_list_2 {
	unsigned short len;
	unsigned short code;
	void *bufadr;
};

struct itm_list_3 {
	unsigned short len;
	unsigned short code;
	void *bufadr;
	unsigned short *retadr;
};

struct vms_timbuf {
	short int year;		/* year since 0 */
	short int mon;		/* month of year */
	short int mday;		/* day of month */
	short int hour;
	short int min;
	short int sec;
	short int hundred;
};

 /* Put in prototypes that actually help get the definitions right */
/*----------------------------------------------------------------*/
#ifdef __GNUC__

 /* prototype for sys$getjpiw() */
/*-----------------------------*/
unsigned long sys$getjpiw
       (unsigned long efn,
	unsigned long * pidadr,
	const struct dsc$descriptor_s * prcnam,
	const struct itm_list_3 * itmlist,
	void * iosb,
	void (* astadr)(),
	const unsigned long astprn);

 /* prototype for sys$getquiw() */
/*-----------------------------*/
unsigned long sys$getquiw
       (const unsigned long efn,
	const unsigned short func,
	unsigned long * context,
	const struct itm_list_3 * itmlist,
	void * iosb,
	void (* astadr) (),
	const unsigned long astprn);


 /* prototype for sys$numtim */
/*--------------------------*/
unsigned long sys$numtim
       (unsigned short * timbuf,
	const void * timadr);

 /* prototype for sys$setprn() */
/*----------------------------*/
unsigned long sys$setprn
       (const struct dsc$descriptor_s * prcnam);

 /* prototype for sys$bintim() */
/*----------------------------*/
unsigned long sys$bintim
       (const struct dsc$descriptor_s * timbuf,
	void * timadr);

 /* prototype for sys$getdviw() */
/*-----------------------------*/
unsigned long sys$getdviw
       (const unsigned long efn,
	const unsigned short chan,
	const struct dsc$descriptor_s * devnam,
	const struct itm_list_3 * itmlist,
	void * iosb,
	void (* astadr) (),
	const unsigned long astprn,
	const unsigned long nullarg);

 /* prototype for sys$cantim() */
/*----------------------------*/
unsigned long sys$cantim
       (const unsigned long reqidt,
	const unsigned long acmode);

 /* prototype for sys$setimr() */
/*----------------------------*/
unsigned long sys$setimr
       (const unsigned long efn,
	const void * daytim,
	void (* astadr) (),
	const unsigned long reqidt,
	const unsigned long flags);

 /* prototype for lib$delete_file() */
/*---------------------------------*/
unsigned long lib$delete_file
       (const struct dsc$descriptor_s * filespec,
	const struct dsc$descriptor_s * def_filespec,
	const struct dsc$descriptor_s * rel_filespec,
	void (* user_success) (),
	void (* user_error) (),
	void (* user_confirm) (),
	const unsigned long userarg,
	struct dsc$descriptor_s * res_filespec,
	unsigned long * context);

 /* prototype for lib$create_dir() */
/*--------------------------------*/
unsigned long lib$create_dir
       (const struct dsc$descriptor_s * dir_spec,
	const unsigned long * uic,
	const unsigned short * prot_enable,
	const unsigned short * prot_value,
	const unsigned short * max_vers,
	const unsigned short * rel_vol_num,
	const unsigned short * allocation);

 /* prototype for lib$spawn() */
/*---------------------------*/
unsigned long lib$spawn
       (const struct dsc$descriptor_s * command,
	const struct dsc$descriptor_s * infile,
	const struct dsc$descriptor_s * outfile,
	const unsigned long * flags,
	const struct dsc$descriptor_s * procname,
	unsigned long * procid,
	unsigned long * comp_stat,
	const unsigned char * event_flag_num,
	void (* astadr) (),
	const unsigned long astarg,
	const struct dsc$descriptor_s * prompt,
	const struct dsc$descriptor_s * cli,
	const struct dsc$descriptor_s * table);

 /* prototype for smg$create_virtual_keyboard() */
/*--------------------------------------------*/
unsigned long smg$create_virtual_keyboard
       (unsigned long * keyboard_id,
	const struct dsc$descriptor_s * input_dev,
	const struct dsc$descriptor_s * def_filespec,
	struct dsc$descriptor_s * res_filespec,
	const unsigned char * recall);

 /* prototype for smg$read_string() */
/*---------------------------------*/
unsigned long smg$read_string
       (const unsigned long * keyboard_id,
	struct dsc$descriptor_s * res_string,
	const struct dsc$descriptor_s * prompt,
	const long * maxlen,
	const unsigned long * modifiers,
	const long * timeout,
	const void * termset,
	unsigned short * res_length,
	unsigned short * term_code,
	unsigned long * display_id,
	const struct dsc$descriptor_s * init_string,
	const unsigned long * rendition_set,
	const unsigned long * rendition_compl,
	struct dsc$descriptor_s * term_string);
#endif

BOOL vms_lp_share_modes(i)	/* HACK to switch off share modes */
{
	return(FALSE);
}

/*
 * vms_set_process_name
 */

void vms_set_process_name(const char * name)
{
int lgth;
struct dsc$descriptor_s prcnam;
unsigned long call_stat;

    lgth = strlen(name);
    if (lgth > 15)
	lgth = 15;
    (const char *) prcnam.dsc$a_pointer = name;
    prcnam.dsc$w_length = lgth;
    prcnam.dsc$b_class = DSC$K_CLASS_S;
    prcnam.dsc$b_dtype = DSC$K_DTYPE_T;

    call_stat = sys$setprn(&prcnam);
}


/*
 * vms_process_exists
 */
int vms_process_exists(const unsigned long pid)
{
unsigned long call_stat;
unsigned long ret_stat;
unsigned long ret_pid;
unsigned short ret_pid_len;

struct itm_list_3 jpi_list[2];


    jpi_list[0].code = JPI$_PID;
    jpi_list[0].len = 4;
    jpi_list[0].bufadr = &ret_pid;
    jpi_list[0].retadr = &ret_pid_len;

    jpi_list[1].code = 0;
    jpi_list[1].len = 0;

/*    sts = lib$getjpi(&item,&pid,0,&result,0,0); */

    ret_pid = pid;

    call_stat = sys$getjpiw(0, &ret_pid, NULL, jpi_list, NULL, NULL, 0);

    ret_stat = call_stat & SS$_NORMAL;

    return ret_stat;
}

/* 17-Nov-1998	J. Malmberg	time to get rid of this and see what breaks */
#if 0
/*
 * Make a suitable VMS file name from a DOS long filename (in UNIX syntax).
 * Characters not possible for a VMS filename are replaced by '__NN' where
 * 'NN' is the two-digit hex ASCII code.
 *
 * The resultant string is returned in a static buffer.
 */
static char buffer[256];

/* yes this is GROSS, need it to workaround redefinitions of
   strcpy and strcat in includes.h */

#undef strcpy
#undef strcat
/* #define strcpy(d,s) safe_strcpy((d),(s),sizeof(buffer)-1)
** #define strcat(d,s) safe_strcat((d),(s),sizeof(buffer)-1)
*/
#undef sprintf
int    sprintf  (char *__s, const char *__format, ...);

 /* KANJI.H zaps these routines for the unsuspecting */
/*--------------------------------------------------*/
#undef strchr
#undef strrchr

char *vms_make_name(char *fname)
{
	char escbuf[5];
	char *p,*q;
	int dotcnt = 0;
	int ulcnt = 0;
	int i;

	for (p=fname, q=buffer; *p != '\0'; p++) {
/*
 * If we find a colon in the name, we assume the filename is already in
 * VMS format. Copy original string over and return.
 */
		if (*p == ':') {
			strcpy(buffer,fname);
			return(buffer);
		}
		if ((*p < 'a' || *p > 'z')
		&& (*p < 'A' || *p > 'Z')
		&& (*p < '0' || *p > '9')
		&& *p != '$' && *p != '-' && *p != '/'
		&& *p != '*' && *p != '?' && *p != '%'
		&& (*p != '.' || dotcnt >= 1)
		&& (*p != '_' || ulcnt >= 1)) {
			if (*p == '_') {
				sprintf(escbuf,"_%02X_",*p & 0xFF);
				strcpy(q, escbuf);
			}
			else {
				ulcnt = 0;
				sprintf(escbuf,"__%02X",*p & 0xFF);
				strcpy(q, escbuf);
			}
			q += 4;
		}
		else {
			*q++ = *p;
			if (*p == '.') dotcnt++;
			if (*p == '/') dotcnt = 0;
			if (*p == '_') {
				ulcnt++;
			}
			else {
				ulcnt = 0;
			}
		}
	}
	*q = '\0';
	return(buffer);
}

/*
 * Make DOS filename from a VMS name.
 */
char *vms_get_name(char *fname)
{
	char escbuf[5];
	char *p,*q;
	int dotcnt = 0;
	int ulcnt = 0;
	int i;

	for (p=fname, q=buffer; *p != '\0'; p++) {
		if (*p == '_') {
			if (ulcnt == 0) {	/* if first underline */
				ulcnt++;
			}
			else {
				p++;
				if (*p == '\0') break;
				sscanf(p,"%02X",q++);
				p++;
				ulcnt = 0;
				if (*p == '\0') break;
			}
		}
		else {
			if (ulcnt > 0) {	/* if single underline */
				*q++ = '_';
				ulcnt = 0;
			}
			*q++ = *p;
		}
	}
	if (ulcnt > 0) *q++ = '_';
	*q = '\0';
	return(buffer);
}
#endif

#define QUI_OK	(QUI$M_QUEUE_AVAILABLE | QUI$M_QUEUE_BUSY | QUI$M_QUEUE_IDLE)
#define QUI_ERROR  (QUI$M_QUEUE_STALLED | QUI$M_QUEUE_UNAVAILABLE)

/*
 * vms_getqui_init
 *
 * Establish a $GETQUI context for a specified queue.
 */
BOOL vms_getqui_init(char *queue_name, print_status_struct *status)
{
	unsigned long sts;
	unsigned long search_flags;
	unsigned long queue_status;
	struct itm_list_3 queue_list[4];
	unsigned long iosb[2];
/*
 * Cancel any previous context.
 */
	sts = sys$getquiw(0,QUI$_CANCEL_OPERATION,0,0,0,0,0);
	if (!(sts & SS$_NORMAL))
	    return(False);
/*
 * Establish queue context.
 */
	queue_list[0].code = QUI$_QUEUE_STATUS;
	queue_list[0].bufadr = &queue_status;
	queue_list[0].len = sizeof(queue_status);
	queue_list[0].retadr = NULL;

	queue_list[1].code = QUI$_SEARCH_NAME;
	queue_list[1].bufadr = queue_name;
	queue_list[1].len = strlen(queue_name);
	queue_list[1].retadr = NULL;

	queue_list[2].code = QUI$_SEARCH_FLAGS;
	queue_list[2].bufadr = &search_flags;
	queue_list[2].len = sizeof(search_flags);
	queue_list[2].retadr = NULL;

	queue_list[3].code = 0;
	queue_list[3].len = 0;

	search_flags = QUI$M_SEARCH_WILDCARD;

	sts = sys$getquiw(0,QUI$_DISPLAY_QUEUE,0,queue_list,iosb,0,0);
	DEBUG(5,("getqui_init:  sts = %08X, iosb = %08X\n",sts,iosb[0]));
	if ( (!(sts & SS$_NORMAL)) || (!(iosb[0] & SS$_NORMAL)) )
	    return(False);

	DEBUG(5,("              queue_status = %08X\n",queue_status));

	if (status) {
		if (queue_status & QUI_OK) {
			strcpy(status->message,"Queue status is OK");
			status->status=LPSTAT_OK;
		}
		else if (queue_status & QUI_ERROR) {
			strcpy(status->message,"Queue status is ERROR");
			status->status=LPSTAT_ERROR;
		}
		else {
			strcpy(status->message,"Queue status is STOPPED");
			status->status = LPSTAT_STOPPED;
		}
	}

	return(True);
}

/*
 * vms_getqui_entry
 *
 * Get job information for next job.
 */
BOOL vms_getqui_entry(print_queue_struct *buf, BOOL first)
{
unsigned long sts;
unsigned long search_flags;
struct itm_list_3 job_list[8];
unsigned long iosb[2];
char job_name[40];
char username[13];
long job_size;
long entry_number;
unsigned long job_status;
unsigned long submission_time[2];
short int job_name_len;
short int username_len;
struct vms_timbuf timbuf;

	job_list[0].code = QUI$_JOB_NAME;
	job_list[0].bufadr = job_name;
	job_list[0].len = 39;
	job_list[0].retadr = &job_name_len;

	job_list[1].code = QUI$_USERNAME;
	job_list[1].bufadr = username;
	job_list[1].len = 12;
	job_list[1].retadr = &username_len;

	job_list[2].code = QUI$_JOB_SIZE;
	job_list[2].bufadr = &job_size;
	job_list[2].len = sizeof(job_size);
	job_list[2].retadr = NULL;

	job_list[3].code = QUI$_ENTRY_NUMBER;
	job_list[3].bufadr = &entry_number;
	job_list[3].len = sizeof(entry_number);
	job_list[3].retadr = NULL;

	job_list[4].code = QUI$_JOB_STATUS;
	job_list[4].bufadr = &job_status;
	job_list[4].len = sizeof(job_status);
	job_list[4].retadr = NULL;

	job_list[5].code = QUI$_SUBMISSION_TIME;
	job_list[5].bufadr = submission_time;
	job_list[5].len = sizeof(submission_time);
	job_list[5].retadr = NULL;

	job_list[6].code = QUI$_SEARCH_FLAGS;
	job_list[6].bufadr = &search_flags;
	job_list[6].len = sizeof(search_flags);
	job_list[6].retadr = NULL;

	job_list[7].code = 0;
	job_list[7].len = 0;

	search_flags = QUI$M_SEARCH_ALL_JOBS;

	sts = sys$getquiw(0,QUI$_DISPLAY_JOB,0,job_list,iosb,0,0);
	DEBUG(5,("getqui_entry: sts = %08X, iosb = %08X\n",sts,iosb[0]));
	if ( (!(sts & SS$_NORMAL)) ||  (!(iosb[0] & SS$_NORMAL)) )
	    return(False);

	job_name[job_name_len] = '\0';
	username[username_len] = '\0';

	DEBUG(5,("              entry_number = %d\n",entry_number));
	DEBUG(5,("              job_size     = %d\n",job_size));
	DEBUG(5,("              job_status   = %08X\n",job_status));
	DEBUG(5,("              job_name     = {%s}\n",job_name));
	DEBUG(5,("              username     = {%s}\n",username));

	buf->job = entry_number;
	buf->size = job_size * 512;
	buf->status =
		(job_status & QUI$M_JOB_EXECUTING) ? LPQ_PRINTING : LPQ_QUEUED;
	buf->time = time(NULL);
	StrnCpy(buf->user,username,sizeof(buf->user)-1);
	StrnCpy(buf->file,job_name,sizeof(buf->file)-1);

	sts = sys$numtim((unsigned short *)&timbuf, submission_time);
	if (sts & SS$_NORMAL)
	{
		struct tm tm;
		int i;

		i = timbuf.year / 100;
		i = timbuf.year - (i * 100);
		tm.tm_year = i;
		tm.tm_mon = timbuf.mon;
		tm.tm_mday = timbuf.mday;
		tm.tm_hour = timbuf.hour;
		tm.tm_min = timbuf.min;
		tm.tm_sec = timbuf.sec;
		buf->time = posix_mktime(&tm);
/*		buf->time += GMT_TO_LOCAL*TimeDiff(buf->time); */ /* have to fix this */
	}

	return(True);
}

/*
 * statfs - return mounted file system info
 */

/* previous Samba for OpenVMS   #include <sys/vfs.h> */
/* 02-Jul-1998	J. Malmberg	Even better, it is already in the includes.h
  #include "vfs.h"
*/
#ifndef __GNUC__
int vms_statfs(char *path, struct statfs *buf)
#else
int vms_statfs(const char *path, struct statfs *buf)
#endif
{
unsigned long iosb[2];
struct itm_list_3 dvi_itm[5];
unsigned long call_stat;
unsigned long acptype;
unsigned long cluster;
struct dsc$descriptor_s dev;

    DEBUG (3,("vms_statfs: path = \"%s\"", path));

    if (path[0] != '\0')
    {
	dvi_itm[0].code = DVI$_MAXBLOCK;
	dvi_itm[0].len = 4;
	dvi_itm[0].bufadr = &buf->f_blocks;	/* total blocks */
 	dvi_itm[0].retadr = NULL;

	dvi_itm[1].code = DVI$_FREEBLOCKS;
	dvi_itm[1].len = 4;
	dvi_itm[1].bufadr = &buf->f_bfree;	/* free blocks */
	dvi_itm[1].retadr = NULL;

	dvi_itm[2].code = DVI$_MAXFILES;
	dvi_itm[2].len = 4;
	dvi_itm[2].bufadr = &buf->f_files;	/* total files in file system */
	dvi_itm[2].retadr = NULL;

	dvi_itm[3].code = DVI$_ACPTYPE;
	dvi_itm[3].len = 4;
	dvi_itm[3].bufadr = &acptype;		/* ACP Type */
	dvi_itm[3].retadr = NULL;

	dvi_itm[3].code = DVI$_CLUSTER;
	dvi_itm[3].len = 4;
	dvi_itm[3].bufadr = &cluster;		/* Cluster allocation */
	dvi_itm[3].retadr = NULL;

	dvi_itm[5].code = 0;
	dvi_itm[5].len = 0;

	(const char *) dev.dsc$a_pointer = path;
	dev.dsc$w_length = strlen(dev.dsc$a_pointer);
	dev.dsc$b_class = DSC$K_CLASS_S;
	dev.dsc$b_dtype = DSC$K_DTYPE_T;

	call_stat = sys$getdviw(0, 0, &dev, dvi_itm, iosb, 0, 0, 0);
	if ( (!(call_stat & SS$_NORMAL)) || (!(iosb[0] & SS$_NORMAL)) )
	{
	    DEBUG(0,
	      ("vms_statfs: $GETDVI ERROR: sts = %08X, iosb = %08X\n",
	       call_stat, iosb[0]));
	    return(-1);
	}

	buf->f_type = 0;
	buf->f_bsize = 512;			/* unsupported */
	buf->f_bavail = buf->f_bfree;	/* avaiable blocks to non-super-user */
	buf->f_ffree = -1;			/* free files, unsupported */
	DEBUG (4,("   f_blocks = %d\n",buf->f_blocks));
	DEBUG (4,("   f_bfree = %d\n",buf->f_bfree));
	DEBUG (4,("   f_files = %d\n",buf->f_files));

#ifdef __GNUC__
	buf->f_fsid = acptype;
	buf->f_frsize = buf->f_bsize * cluster;
#endif
	return(0);
    }
    else
    {
	return (-1);
    }
}

/*
 * setgroups - dummy
 */

int vms_setgroups(int ngroups, gid_t gidset[])
{
	return(0);
}


/*
 * waitpid (T.B.S.)
 */
pid_t vms_waitpid(pid_t pid, int *stat, int options)
{
	return(0);
}


/*
 * delete
 *
 * Get the VMS filespec and delete all versions of the file.
 */
int vms_delete (const char *path)
{
char buf[256];
unsigned long call_stat;
struct dsc$descriptor_s nam;

    strcpy(buf, path);
    if(path[0] == '\0')
    {
	errno = ENOENT;
	return(-1);
    }
    strcat(buf,";*");

    nam.dsc$a_pointer = buf;
    nam.dsc$w_length = strlen(nam.dsc$a_pointer);
    nam.dsc$b_class = DSC$K_CLASS_S;
    nam.dsc$b_dtype = DSC$K_DTYPE_T;

    call_stat = lib$delete_file(&nam, 0, 0, 0, 0, 0, 0, 0, 0);

    if ((call_stat & SS$_NORMAL) == SS$_NORMAL)
	return(0);

     /* Compensate for old behavior */
    /*-----------------------------*/
    if (SAMBA_VMS_FILEOPTS & LONGFILE_M_EXTLASTDOT)
    {
    int temp_opts;

	vms_to_longfile(buf, buf, 0);
	temp_opts = SAMBA_VMS_FILEOPTS;
	temp_opts = temp_opts & ~LONGFILE_M_EXTLASTDOT;
	longfile_to_vms(buf, buf, temp_opts);
	strcat(buf,";*");
    }

    call_stat = lib$delete_file(&nam, 0, 0, 0, 0, 0, 0, 0, 0);

    if ((call_stat & SS$_NORMAL) == SS$_NORMAL)
	return(0);

    DEBUG(1,("VMS-error %d deleting %s\n", call_stat, buf));
    errno = EACCES;
    return -1;
}

#ifdef chmod
#undef chmod
#endif

/*
 * chmod
 *
 * change the protection of the files
 */
int vms_chmod(const char * file, unsigned mode)
{
char buf[256];
int ret_stat;

    if (file[0] != '\0')
    {
	DEBUG(3,("vms_chmod: was: %s -> %o\n", file, mode));
	vms_dir_to_file(buf, file);

	DEBUG(3,("vms_chmod: VMS: %s -> %o\n",buf, mode));
	ret_stat = chmod(buf, mode);

	 /* Compensate for old behavior */
	/*-----------------------------*/
	if (ret_stat == -1)
	{
	    if (SAMBA_VMS_FILEOPTS & LONGFILE_M_EXTLASTDOT)
	    {
	    int temp_opts;

		vms_to_longfile(buf, buf, 0);
		temp_opts = SAMBA_VMS_FILEOPTS;
		temp_opts = temp_opts & ~LONGFILE_M_EXTLASTDOT;
		longfile_to_vms(buf, buf, temp_opts);
	    }
	    ret_stat = chmod(buf, mode);
	}
    }
    else
    {
	ret_stat = -1;
    }

    return ret_stat;
}

#ifdef rename
#undef rename
int rename (const char *__old, const char *__new);
#endif
/*
 * rename
 *
 * Rename files. Take care of VMS directory files.
 */
#ifndef __GNUC__
int vms_rename(char *oldname, char *newname)
#else
int vms_rename(const char *oldname, const char *newname)
#endif
{
char buf[256];
int len;
int ret_stat;

    DEBUG(3,("vms_rename: was: %s -> %s\n",oldname,newname));
    len = strlen(oldname);
    if (len > 0)
    {
	vms_dir_to_file(buf, oldname);

	DEBUG(3,("vms_rename: VMS: %s -> %s\n",buf, newname));
	ret_stat = rename(buf, newname);

	 /* Compensate for old behavior */
	/*-----------------------------*/
	if (ret_stat == -1)
	{
	    if (SAMBA_VMS_FILEOPTS & LONGFILE_M_EXTLASTDOT)
	    {
	    int temp_opts;

		vms_to_longfile(buf, buf, 0);
		temp_opts = SAMBA_VMS_FILEOPTS;
		temp_opts = temp_opts & ~LONGFILE_M_EXTLASTDOT;
		longfile_to_vms(buf, buf, temp_opts);
	    }
	    ret_stat = rename(buf, newname);
	}
    }
    else
    {
	ret_stat = -1;
    }

    return ret_stat;
}


/*
 * mkdir
 *
 * Yes, even VAXC has mkdir. But we would like to really know,
 * what mkdir() really does...
 *
 * This is a special version for Samba: We ignore 'mode' and just
 * use the parent directory protection.
 */
#ifndef __GNUC__
int vms_mkdir( char *name, mode_t mode, ...)
#else
int vms_mkdir(const char * name, mode_t mode, ...)
#endif
{
char outfile[256];
int result;
unsigned long call_stat;

unsigned short penable = 0xFFFF;	/* copy system protect from parent */
#if 0
unsigned short penable = 0;	  /* copy all from parent! */
#endif
unsigned short protect = 0;

struct dsc$descriptor_s nam;
const char prot_unix2vms[8]={0,4,10,14,1,5,11,15};

int dir_cnt1;
int dindx;
int dindx1;
int dir_len;
char *dchar1;
char dir_start;
char dir_end;

    DEBUG(0,("vms_mkdir: %s, mode: %07o\n", name, mode));

     /* Since SAMBA has already converted the file to VMS format */
     /* All we must do here is move the directory terminator to  */
     /* the end of the file spec.  Not as easy as it seems       */
     /* have to count the directory dots.			 */

     /* Could translate back to UNIX/DOS format, add a slash	*/
     /* And then translate back to VMS, but that is a lot more  */
     /* overhead						*/

    dindx = 0;
    dindx1 = 0;
    dir_cnt1 = 0;

     /* Find the start of the directory path */
    /*--------------------------------------*/
    dir_start = '[';
    dir_end = ']';
    dchar1 = strchr(name, '[');
    if (dchar1 == NULL)
    {
	dir_start = '<';
	dir_end = '>';
	dchar1 = strchr(name, '<');
    }

    dir_len = strlen(name);
    if (name[dir_len - 1] == dir_end)
    {
	 /* The directory is already in the right form */
	/*--------------------------------------------*/
	strncpy(outfile, name, dir_len);
	outfile[dir_len] = '\0';
    }
    else
    {
	 /* Must rebuild the directory format */
	/*-----------------------------------*/
	if (dchar1 != NULL)
	{
	int dcnt0;
	    dcnt0 = (long)dchar1 - (long)name + 1;
	    strncpy(outfile, name, dcnt0);
	    dindx = dcnt0;
	    dindx1 = dcnt0;
	}

	 /* Get the rest of the directory path */
	/*------------------------------------*/
	do
	{
	char * dchar1_1;

	    dchar1 = strchr(&name[dindx1], '.');
	    dchar1_1 = strrchr(&name[dindx1], dir_end);
	    if (dchar1 == NULL)
	    dchar1 = dchar1_1;

	    if (dchar1 != NULL)
	    {
	    int dcnt1;

		 /* Need a dot */
		/*------------*/
		dir_cnt1++;
		if (dir_cnt1 > 1)
		{
		    outfile[dindx] = '.';
		    dindx++;
		}

		 /* Redo the root if needed */
		/*-------------------------*/
		if ((dir_cnt1 == 8)
		   && (SAMBA_VMS_FILEOPTS & LONGFILE_M_DEEPDIR))
		{
		    outfile[dindx] = dir_end;
		    dindx++;
		    outfile[dindx] = dir_start;
		    dindx++;
		}

		dcnt1 = (long)dchar1 - (long)&name[dindx1];
		strncpy(&outfile[dindx], &name[dindx1], dcnt1);
		dindx = dindx + dcnt1;
		dindx1 = dindx1 + dcnt1 + 1;

		if ((dchar1[1] == dir_end) && (dchar1[2] == dir_start))
		    dindx1 = dindx1 + 2;
		if (*dchar1 == dir_end)
		{
		int len;

		    dchar1++;
		    outfile[dindx] = '.';
		    dindx++;

		    if ((dir_cnt1 == 8)
			&& (SAMBA_VMS_FILEOPTS & LONGFILE_M_DEEPDIR))
		    {
			outfile[dindx] = dir_end;
			dindx++;
			outfile[dindx] = dir_start;
			dindx++;
		    }
		    strcpy(&outfile[dindx], dchar1);
		    len = strlen(outfile);
		    outfile[len] = dir_end;
		    len++;
		    outfile[len] = '\0';
		    break;
		}
	    }
	} while (dchar1 != NULL);
    }

    nam.dsc$a_pointer = outfile;
    nam.dsc$w_length = strlen(outfile);
    nam.dsc$b_class = DSC$K_CLASS_S;
    nam.dsc$b_dtype = DSC$K_DTYPE_T;

    protect = prot_unix2vms[mode & 7];
    mode >>= 3;
    protect <<= 4; /*world*/
    protect |= prot_unix2vms[mode & 7];
    mode >>= 3;
    protect <<= 4; /*group*/
    protect |= prot_unix2vms[mode & 7];
    mode >>= 3;
    protect <<= 4; /*owner*/
    protect |= prot_unix2vms[mode & 7];

    protect = ~protect;

    call_stat = lib$create_dir
		       (&nam,
			NULL,
			&penable,
			&protect,
			NULL,
			NULL,
			NULL);

    if (call_stat == SS$_CREATED)
    {
	result = 0;
    }
    else
    {
	result = -1;
	if (call_stat == SS$_NORMAL)
	    errno = EEXIST;
	else
	    errno = EACCES;
    }

    DEBUG(8,
	("mkdir: sts = %08X, name = %s, mask = %04X\n",
	 call_stat, nam.dsc$a_pointer, protect));

    return result;
}


#ifdef delete
#undef delete
int delete(const char *__path);
#endif
/*
 * rmdir
 *
 * Get the VMS directory filespec and delete the <path>.DIR;1 file.
 */
int vms_rmdir (char *path)
{
char buf[256];
int sts;
int len;

    len = strlen(path);
    if (len == 0)
    {
	errno = ENOTDIR;
	sts = -1;
    }
    else
    {
	if ((path[len - 1] == '>') || (path[len - 1] == ']'))
	{

	    vms_dir_to_file(buf, path);

	    DEBUG(3,("Deleting directory %s --> %s\n", path, buf));
	    sts = delete(buf);
	    if (sts < 0)
	    {
		DEBUG(3,
		("rmdir: errno = %d, vaxc$errno = %08X\n", errno, vaxc$errno));
		if (errno == EVMSERR)
		{
		    if (vaxc$errno == RMS$_MKD)
			errno = ENOTEMPTY;
		}
	    }
	}
	else
	{
	    errno = ENOTDIR;
	    sts = -1;
	}
    }
    return sts;
}


/*
 * ftruncate
 * (SAMBA only !? does it ever really shorten a file? - we only support
 * extension for now...)
 */

int vms_ftruncate(int f,off_t l)
{
/*
 * I believe that lseek does extension correctly...
 */
	if(lseek(f, l, SEEK_SET) != l)
		return(-1);
	return(0);
}

#if 0
#ifndef __DECC
#define decc$to_vms shell$to_vms
#endif

int decc$to_vms(char * __unixfile,
		int (* __action_routine)(char * __vmsfile, int __type),
		int __wild_flag,int __no_dir_flag);

static char vms_file[256];
static int vms_file_type;

static int vms_action_routine(char *s, int type)
{
	vms_file_type = type;
	strcpy(vms_file,s);
	return(1);
}

char *cvt_file_to_vms(char *unixfile)
{
	if (unixfile == NULL) return(NULL);
	strcpy(vms_file, unixfile);
	decc$to_vms(unixfile, vms_action_routine, 0, 1);
	return(vms_file);
}
#endif
/*
 * system
 *
 * This version of the system() call tries to detect an output redirection
 * in the UNIX compatible command and if found, spawns the subprocess
 * with SYS$OUTPUT assigned to the specified path.
 *
 * Input redirection is not supported - SYS$INPUT is set to NLA0:
 */
int vms_system(const char *cmdline)
{
	char buf[256];
	$DESCRIPTOR(in,"NLA0:");
	$DESCRIPTOR(out,"SYS$OUTPUT");
	$DESCRIPTOR(cmd,"");
	unsigned long sts;
	unsigned long compl;
	char *p, *q;

	strcpy(buf,cmdline);
	cmd.dsc$a_pointer = buf;
	if (buf[0] == '\"') cmd.dsc$a_pointer++;

	if(strlen(buf) > 0)
		if (buf[strlen(buf) - 1] == '\"') buf[strlen(buf) - 1] = '\0';
	p = strrchr(cmd.dsc$a_pointer,'>');
	if (p != NULL) {
		for (q = p + 1; *q == ' ' && *q != '\0'; q++);
		longfile_to_vms(out.dsc$a_pointer, q, SAMBA_VMS_FILEOPTS);
		if (strcmp(out.dsc$a_pointer,"/dev/null") == 0) {
			out.dsc$a_pointer = in.dsc$a_pointer;
		}
		if (p != cmd.dsc$a_pointer && *(p-1) == '>') p--;
		*p = '\0';
	}
	cmd.dsc$w_length = strlen(cmd.dsc$a_pointer);
	out.dsc$w_length = strlen(out.dsc$a_pointer);
	sts = lib$spawn(&cmd,&in,&out,0,0,0,&compl,0,0,0,0,0,0);
DEBUG(5,("system: {%s}, output: {%s}\n",cmd.dsc$a_pointer,out.dsc$a_pointer));
DEBUG(5,("        sts = %08X, compl = %08X\n",sts,compl));
	if (!(sts & SS$_NORMAL)) return(127);
	return((int)compl);
}


/* ======= keyboard ========================================== */

/*
 * vms_read_keyboard
 *
 * This routine has to read from keyboard and to check the socket for
 * incoming data (see wait_keyboard in client.c).
 *
 * As we can't use select() for the keyboard we call the keyboard read
 * routine synchroneously. Before, a cyclic timer is started which
 * checks the network. Note that the checking routine is called at
 * AST level. The only drawback is that there is a delay until a
 * network action is noticed, but this seems no problem here.
 *
 * To enable command line editing we use the SMG routines to read from
 * keyboard.
 *
 * I tried to strictly separate the VMS specific code from the base
 * samba code. So this routine is in a common VMS support module but has
 * a callback into the client.c. To avoid unresolved symbols with executables
 * other than smbclient, the callback address is included as a parameter
 * to vms_read_keyboard.
 */
#include <smgdef.h>
#include <smgmsg.h>
#include <ssdef.h>
#include <smg$routines.h>

static unsigned long smg_kb_id = -1;
static long time_bin[2];
char time_string[] = "0 00:00:01.01";
$DESCRIPTOR(time_dsc,time_string);
static char *smbbuffer;
static void (* client_chk_routine)();

void timer_ast(int reqid)
{
	unsigned long sts;
	void vms_check_net(char * __buffer, int __flag);

/*	DEBUG (3,("== timer AST ==\n")); */ /**/
	(* client_chk_routine)(smbbuffer);	/* Callback to client.c */
	sts = sys$setimr(0,time_bin,timer_ast,reqid,0);	/* restart */
}

int vms_read_keyboard(char *prompt, char *line, int size, char *buffer,
		void (* chk_routine)() )
{
	unsigned long sts;
	int retlen;
	struct dsc$descriptor_s dsc_line, dsc_prompt;
	struct dsc$descriptor_s *prm;
	void vms_exit_handler();

	smbbuffer = buffer;
	client_chk_routine = chk_routine;
	dsc_line.dsc$a_pointer = line;
	dsc_line.dsc$w_length = size - 1;
	dsc_line.dsc$b_class = DSC$K_CLASS_S;
	dsc_line.dsc$b_dtype = DSC$K_DTYPE_T;
	if (prompt == NULL) {
		prm = NULL;
	}
	else {
		dsc_prompt.dsc$a_pointer = prompt;
		dsc_prompt.dsc$w_length = strlen(prompt);
		dsc_prompt.dsc$b_class = DSC$K_CLASS_S;
		dsc_prompt.dsc$b_dtype = DSC$K_DTYPE_T;
		prm = &dsc_prompt;
	}

	if (smg_kb_id == -1) {
		sts = smg$create_virtual_keyboard(&smg_kb_id,0,0,0,0);
		if (!(sts & SS$_NORMAL)) {
		    DEBUG (0,("can't create SMG keyboard - sts = %08X\n",sts));
			return(-1);
		}
		sts = sys$bintim(&time_dsc,time_bin);
		if (!(sts & SS$_NORMAL)) {
			DEBUG (0,("$BINTIM error - sts = %08X\n",sts));
			return(-1);
		}
	}
/*
 * Start cyclic timer.
 */
	sts = sys$setimr(0,time_bin,timer_ast,1,0);
	if (!(sts&1)) {
		DEBUG (0,("$SETIMR error - sts = %08X\n",sts));
		return(-1);
	}
/*
 * Read from keyboard.
 */
	retlen = 0;
	sts = smg$read_string(&smg_kb_id, &dsc_line, prm,
				0, 0, 0, 0, &retlen, 0,0,0,0,0,0);
	*(dsc_line.dsc$a_pointer + retlen) = '\0';
/*
 * We got a command line. Cancel timer and return.
 */
	sys$cantim(1,0);
	if (sts == SS$_NORMAL) return(0);
	if (sts == SMG$_EOF) return(-1);
	DEBUG (0,("keyboard read error: sts = %08X\n",sts));
	return(-1);
}

#if 1	/* for debug only */
/************************************************************/
/* dmphx - dump a buffer to the debug log in hex and ascii  */
/************************************************************/
void _dmphx(char *msg,int len)
{
  int i, j;
  unsigned char *v, *w;

  v = w = (unsigned char *)msg;
  j = len;
  while (j>0) {
     if (j>16) i = 16; else i=j;
     for(;i>0;i--,v++) Debug1(" %02x",*v);
     if (j<16) for(i=16-j;i>0;i--) Debug1("   ");
     Debug1("        ");
     if (j>16) i = 16; else i=j;
     for(;i>0;i--,w++) Debug1("%c",(*w>0x1f && *w<0x80)? *w : '.');
     Debug1("\n");
     j -= 16;
  }
}
#endif
